package com.javaseleniumtemplate.pages;

import com.aventstack.extentreports.reporter.configuration.Theme;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;

public class GeracaodeProdutoAcabadoPage extends PageBase {
    By menubutton = By.xpath("//*[@class='bars']");
    By campopesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By geracaoprodutoacabadobutton = By.xpath("//span[text()='Geração do Produto Acabado']");

    // GERAR PRODUTO ACABADO
    By lupaselecionarPlanejamentodaProducao = By.xpath("//*[@id='NRPLANPROD']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarplanejamentodaproducao = By.xpath("//span[text()='167']");
    By filtrarbutton = By.xpath("//span[text()='Filtrar']");
    By msggeracaoconcluida = By.xpath("//p[text()='Processo realizado com sucesso!']");

    // SELECIONAR PRODUTO ACABADO E GERAR
    By gerarprodutoacabadofield = By.xpath("//*[@data-zh-id='10235039962714563216361']");
    By alertaprodutosnaoincluidosestoque = By.xpath("//span[text()='OK']");

    // Campos do Filtro
    By adicionarprodutoacabadoButton = By.xpath("//*[@data-zh-id=\"10235039962294950415198\"]");
    By informardataField = By.id("DTCONSUMO");
    By adicionaragregadaField = By.id("CDFILIAL");
    By selecionaragregada = By.xpath("//span[text()='DEPOSITO BC 111']");
    By okagregadaButton = By.xpath("//span[text()='Ok']");
    By adicionarservicoField = By.id("FILISERV");
    By selecionarservico = By.xpath("//span[text()='ALMOÇO']");
    By okservicoButton = By.xpath("//span[text()='Ok']");
    By clicaremfiltrarButton = By.xpath("//span[text()='Filtrar']");

    // Campos de Adicionar o Produto Acabado
    By lupaprodutoacabado = By.xpath("//*[@id='NMPRODUTO']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selecionarprodutoacabado = By.xpath("//span[text()='OLEO DE CASTANHA DO BRASIL']");
    By lupaselecionartipodeprato = By.xpath("//*[@id='NMTIPOPRAT']//span[@class='zh-icon zh-icon-search zh-icon-no-border']");
    By selecionartipodeprato = By.xpath("//span[text()='ARROZ']");
    By selecionarunidadeeserviço = By.xpath("//span[text()='ALMOÇO']");
    By alterarcomensaisField = By.xpath("//*[class='editable-content']");
    By confirmarButton = By.xpath("//span[text()='Confirmar']");

    // Excluir itens adicionados
    By excluirprodutosadicionadosbutton = By.xpath("//*[@class='zh-icon zh-icon-trash zh-icon-color-black']");
    By selecionarprodutoadicionadobutton = By.xpath("//span[text()='OLEO DE CASTANHA DO BRASIL']");
    By simbutton = By.xpath("//span[text()='Sim']");

    // Quantidade Extra ou Perda
    By selecionarprodutobutton = By.xpath("//span[text()='OLEO DE CASTANHA DO BRASIL']");
    By clicaremeditarbutton = By.xpath("//*[@class='zh-action-label ng-binding']");
    By quantidadeextrafield = By.id("QTEXTRA");
    By quantidadeperdafield = By.id("QTPERDA");
    By salvarqtextraouperdabutton = By.xpath("//span[text()='Salvar']");

    // Aba Geração Parcial
    By selecionarabageracaoparcial = By.xpath("//a[text()='Geração Parcial']");
    By adicionargeracaoparcialbutton = By.xpath("//span[text()='Adicionar']");
    By quantidadeproduzidafield = By.id("QTPRODUZIDO");
    By salvarabageracaoparcialbutton = By.xpath("//span[text()='Salvar']");
    By voltarbutton = By.xpath("//span[text()='Voltar']");


    // Aba Consumo por Unidade Agregada
    By selecionarabaconsumoporunidadeagregada = By.xpath("//a[text()='Consumo por Unidade Agregada']");
    By selecionaragregadabutton = By.xpath("//span[text()='DEPOSITO BC 111']");
    By excluiragregadabutton = By.xpath("//span[text()='Excluir']");
    By botaovoltar = By.xpath("//span[text()='Voltar']");


    //Actions
    public void AcessarTela() {
        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(menubutton);
        sendKeys(campopesquisar, "Geração do Produto Acabado");
        click(geracaoprodutoacabadobutton);
    }

    public void selecionarplanejamento() {
        click(lupaselecionarPlanejamentodaProducao);
        click(selecionarplanejamentodaproducao);
        click(filtrarbutton);
    }

    public void gerarplanejamento(){
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(gerarprodutoacabadofield);
        click(alertaprodutosnaoincluidosestoque);
    }


    // Adicionar filtro após clicar em Adicionar
    public void AdicionarFiltro(String datadeconsumo) {
        click(adicionarprodutoacabadoButton);
        click(informardataField);
        sendKeys(informardataField, datadeconsumo);
        click(adicionaragregadaField);
        click(selecionaragregada);
        click(okagregadaButton);
        click(adicionarservicoField);
        click(selecionarservico);
        click(okservicoButton);
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(clicaremfiltrarButton);
    }

     //Adicionar o produto acabado
    public void Adicionarprodutoacabado() {
        click(lupaprodutoacabado);
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        click(selecionarprodutoacabado);
        click(lupaselecionartipodeprato);
        click(selecionartipodeprato);
        click(selecionarunidadeeserviço);
        Actions edit = new Actions(driver);
        WebElement element = driver.findElement(alterarcomensaisField);
        edit.moveToElement(element).click();
        edit.sendKeys(element, Keys.BACK_SPACE);
        edit.sendKeys(element, "10").build().perform();
        click(confirmarButton);
    }

     //Excluir Produto Extra Adicionado
    public void Excluiritenincluso(){
        click(excluirprodutosadicionadosbutton);
        click(selecionarprodutoadicionadobutton);
        click(simbutton);
    }

     //Editar Quantidade Extra ou Perda --- ADICIONAR NO TESTE
    public void AdicionarQuantidadeExtraouPerda(String quantextra, String quantperda ){
        click(selecionarprodutobutton);
        click(clicaremeditarbutton);
        click(quantidadeextrafield);
        sendKeys(quantidadeextrafield,quantextra);
        click(quantidadeperdafield);
        sendKeys(quantidadeperdafield,quantperda);
        click(salvarqtextraouperdabutton);
    }

     //Aba geração parcial
    public void GeraçaoParcial(){
        click(selecionarabageracaoparcial);
        click(adicionargeracaoparcialbutton);
        click(quantidadeproduzidafield);
        //sendKeys(quantidadeperdafield);
        click(salvarabageracaoparcialbutton);
        click(voltarbutton);
    }

     //Consumo por Unidade Agregada
    public void ConsumoporUnidadeAgregada(){
        click(selecionarabaconsumoporunidadeagregada);
        click(selecionaragregadabutton);
        click(excluiragregadabutton);
        click(botaovoltar);

    }

    public String geracaoprodutoacabadoconcluida(){
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        return getText(msggeracaoconcluida);

    }

}